/*___________________________________________________________________________
blink_main.ASM    ADSP-2126x Blink Parallel Port Flash Overlay Example

ISR and main function to call the overlays contained in blink_1st.asm,
blink_mid.asm, and blink_last.asm.

ovly_mgr.asm is the overlay manager which is called when any of the functions
in the overlay are called.

__________________________________________________________________________*/
.extern plt_1__.blink_first_stages;
.extern _OvlSecInfo.end;

/* Include for symbolic definition of system register bits */
#include <def21262.h>
#include "ovlay.h"

/************************************************************************/
/*  Interrupt Vector table                              */
.SECTION/PM     isr_tabl;

/* The loader begins with the interrupts up to and including the low    */

        NOP;NOP;NOP;NOP;        /* Reserved interrupt               */
___lib_RSTI:    NOP;
        JUMP _main (db);    /* Jump to main                     */
        NOP;NOP;
___lib_IICDI:
        NOP;NOP;NOP;NOP;        /* Reserved interrupt               */

/* Vector for status stack/loop stack overflow or PC stack full:        */
___lib_SOVFI:   RTI;RTI;RTI;RTI;

/* Vector for high priority timer interrupt:                            */
___lib_TMZHI:   RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */

___lib_BKPI:    RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */
        
___lib_IRQ2I:   RTI;RTI;RTI;RTI;
___lib_IRQ1I:   RTI;RTI;RTI;RTI;
___lib_IRQ0I:   RTI;RTI;RTI;RTI;

___lib_DAIHI:   RTI;RTI;RTI;RTI;
___lib_SPIHI:   RTI;RTI;RTI;RTI;

___lib_GPTMR0I: RTI;RTI;RTI;RTI;

/* Vectors for Serial port DMA channels:                                */
___lib_SP1I:    RTI;RTI;RTI;RTI;
___lib_SP3I:    RTI;RTI;RTI;RTI;
___lib_SP5I:    RTI;RTI;RTI;RTI;
___lib_SP0I:    RTI;RTI;RTI;RTI;
___lib_SP2I:    RTI;RTI;RTI;RTI;
___lib_SP4I:    RTI;RTI;RTI;RTI;

/* Vector for the Parallel Port                              */
___lib_PPI:     NOP;RTI;RTI;RTI;

___lib_GPTMR1I: RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */
        
___lib_DAILI:   RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */

___lib_GPTMR2I: RTI;RTI;RTI;RTI;                
___lib_SPILI:   RTI;RTI;RTI;RTI;

/* Vector for DAG1 buffer 7 circular buffer overflow                    */
___lib_CB7I:    RTI;RTI;RTI;RTI;

/* Vector for DAG2 buffer 15 circular buffer overflow               */
___lib_CB15I:   RTI;RTI;RTI;RTI;

/* Vector for lower priority timer interrupt                    */
___lib_TMZLI:   RTI;RTI;RTI;RTI;

/*                                              */
/************************************************************************/

.EXTERN blink_first_stages;
.EXTERN blink_middle_stages;
.EXTERN blink_next_to_last;
.EXTERN blink_last_stage;
.EXTERN initialize_overlays;
.EXTERN _OvlSecInfo;
.EXTERN _OvlInit;
.GLOBAL _main;

.SECTION/PM             pm_code;
_main: nop;
    // enable pp interrupt
      bit clr LIRPTL PPI; nop;
      bit set LIRPTL PPIMSK; nop;
      bit set mode1  IRPTEN; nop;

      call _OvlInit;
      call _OvlSecInfo;
      call a5_overlay_holder;
      call blink_first_stages;
      call a5_overlay_holder;
      call blink_middle_stages;
      call a5_overlay_holder;
      call blink_next_to_last;
      call a5_overlay_holder;
      call blink_last_stage;
      call a5_overlay_holder;
	  jump(pc,-6);
	  

_main.end: jump(pc,0);

a5_overlay_holder:
px1=0xa5a5a5a5;
px2=0xa5a5a5a5;
i11=_OvlSecInfo.end;
m11=1;
lcntr = dm(longest);

do (pc,1) until lce;
pm(i11,m11)=px;

rts;
