/*___________________________________________________________________________
blink_main.ASM    ADSP-2126x Blink External Memory Overlay Example

ISR and main function to call the overlays contained in blink_1st.asm,
blink_mid.asm, and blink_last.asm.

ovly_mgr.asm is the overlay manager which is called when any of the functions
in the overlay are called.

__________________________________________________________________________*/

/* Include for symbolic definition of system register bits */
#include <def21262.h>
#include "ovlay.h"

/************************************************************************/
/*  Interrupt Vector table                              */
.SECTION/PM     isr_tabl;

/* The loader begins with the interrupts up to and including the low    */

        NOP;NOP;NOP;NOP;        /* Reserved interrupt               */
___lib_RSTI:    NOP;
        JUMP _main (db);    /* Jump to main                     */
        NOP;NOP;
___lib_IICDI:
        NOP;NOP;NOP;NOP;        /* Reserved interrupt               */

/* Vector for status stack/loop stack overflow or PC stack full:        */
___lib_SOVFI:   RTI;RTI;RTI;RTI;

/* Vector for high priority timer interrupt:                            */
___lib_TMZHI:   RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */

___lib_BKPI:    RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */
        
___lib_IRQ2I:   RTI;RTI;RTI;RTI;
___lib_IRQ1I:   RTI;RTI;RTI;RTI;
___lib_IRQ0I:   RTI;RTI;RTI;RTI;

___lib_DAIHI:   RTI;RTI;RTI;RTI;
___lib_SPIHI:   RTI;RTI;RTI;RTI;

___lib_GPTMR0I: RTI;RTI;RTI;RTI;

/* Vectors for Serial port DMA channels:                                */
___lib_SP1I:    RTI;RTI;RTI;RTI;
___lib_SP3I:    RTI;RTI;RTI;RTI;
___lib_SP5I:    RTI;RTI;RTI;RTI;
___lib_SP0I:    RTI;RTI;RTI;RTI;
___lib_SP2I:    RTI;RTI;RTI;RTI;
___lib_SP4I:    RTI;RTI;RTI;RTI;

/* Vector for the Parallel Port                              */
___lib_PPI:     NOP;RTI;RTI;RTI;

___lib_GPTMR1I: RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */
        
___lib_DAILI:   RTI;RTI;RTI;RTI;
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */
        NOP;NOP;NOP;NOP;                /* Reserved interrupt       */

___lib_GPTMR2I: RTI;RTI;RTI;RTI;                
___lib_SPILI:   RTI;RTI;RTI;RTI;

/* Vector for DAG1 buffer 7 circular buffer overflow                    */
___lib_CB7I:    RTI;RTI;RTI;RTI;

/* Vector for DAG2 buffer 15 circular buffer overflow               */
___lib_CB15I:   RTI;RTI;RTI;RTI;

/* Vector for lower priority timer interrupt                    */
___lib_TMZLI:   RTI;RTI;RTI;RTI;

/*                                              */
/************************************************************************/

.EXTERN blink_first_stages;
.EXTERN blink_middle_stages;
.EXTERN blink_next_to_last;
.EXTERN blink_last_stage;
.GLOBAL _main;

.SECTION/PM             pm_code;
_main:
// enable pp interrupt
    bit clr LIRPTL PPI; nop;
    bit set LIRPTL PPIMSK; nop;
    bit set mode1  IRPTEN; nop;
    
     // initiate DMA
    bit set ustat1 PPEN|PPDEN;
    dm(PPCTL)=ustat1; nop;
    
      call blink_first_stages;
      call blink_middle_stages;
      call blink_next_to_last;
      call blink_last_stage;
      jump(pc,-3);

wait:   idle;
    jump wait;
      nop;
      nop;
_main.end:      nop;




