/*  The following code will be the second of 4 overlay functions. */
/*  This function toggles LEDs 1, 4, 5, and 8                    */
/*  The value of these LEDs 1 and 8 are only changed in  */
/*  this function.                                                */
/*  This function will live in external memory in section ovl_code*/
/*  and run in internal memory under section pm_code.             */

#include <def21364.h>
#include "ovlay.h"

.SECTION/PM             pm_code;

blink_middle_stages:
.GLOBAL blink_middle_stages;

// Place AD15:0 into FLAG mode to display the status of the FLAGs register.
ustat1=dm(SYSCTL);nop;
bit set ustat1 PPFLGS|FLG0EN|FLG1EN|FLG2EN|FLG3EN;
dm(SYSCTL)=ustat1;

nop;nop;nop;nop;

// Execute NOP loop to slow execution for visual observation
lcntr=PAUSELENGTH;
    do (pc,1) until lce;
    nop;

// Toggle LEDs 1, 4, 5, 8
bit tgl flags 0x41410000;

// Place AD15:0 into Parallel Port mode to access external memory.
ustat1=dm(SYSCTL);nop;
bit clr ustat1 PPFLGS|FLG0EN|FLG1EN|FLG2EN|FLG3EN;
dm(SYSCTL)=ustat1;


rts;
l4=pm(0x123456);

blink_middle_stages.end:




